<script lang="ts">
    import { updateUserProfileAPI } from "src/apis/update-user-profile";

    import type { AddressModel } from "src/models/address.type";
    import type { Page } from "src/page";

    import {
        billOrderStore,
        pageBackStore,
        pageSelectedStore,
        userProfileStore,
    } from "src/store";
    import AddressDeliveryAutoInput from "src/widgets/AddressDeliveryAutoInput.svelte";

    const addressClean: AddressModel = {
        id: Date.now(),
        fullname: "",
        mobilePhone: "",
        address: "",
        subdistrict: "",
        district: "",
        province: "",
        zipcode: "",
    };

    let formValid = false;

    let address: AddressModel = addressClean;

    async function onAddAddress() {
        if (formValid) {
            if (!$userProfileStore.address) {
                $userProfileStore.address = [];
            }
            $userProfileStore.address.push(address);
            await updateUserProfileAPI($userProfileStore);
            (window as any).location.reload();
        }
    }

    function onBack() {
        $pageSelectedStore = $pageBackStore;
    }
</script>

<div class="w-2/3 mx-auto flex flex-col justify-center mt-4">
    <div
        class="flex justify-center bg-green-600 text-white rounded-t py-5 items-center"
    >
        <div on:click={onBack} class="flex-1 div-2 cursor-pointer">
            <svg
                xmlns="http://www.w3.org/2000/svg"
                class="h-6 w-6 mx-4"
                fill="none"
                viewBox="0 0 24 24"
                stroke="currentColor"
            >
                <path
                    stroke-linecap="round"
                    stroke-linejoin="round"
                    stroke-width="2"
                    d="M10 19l-7-7m0 0l7-7m-7 7h18"
                />
            </svg>
        </div>
        <p class="flex-1 px-2 text-center">เพิ่มที่อยู่ในการส่งของ</p>
        <p class="flex-1 px-2" />
    </div>
    <AddressDeliveryAutoInput
        bind:formValid
        on:formValid={({ detail }) => {
            address = Object.assign(detail, {
                id: Date.now(),
            });
        }}
        on:formClear={() => {
            address = addressClean;
        }}
    />

    <button
        class:bg-green-600={formValid}
        class:bg-gray-300={!formValid}
        class="px-4 py-2 text-white rounded-full mx-2 my-5"
        on:click={onAddAddress}>เพิ่ม</button
    >
</div>
